Index: libcfs/include/libcfs/libcfs_prim.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs_prim.h,v
retrieving revision 1.7
diff -u -p -r1.7 libcfs_prim.h
--- libcfs/include/libcfs/libcfs_prim.h	1 Dec 2009 02:23:43 -0000	1.7
+++ libcfs/include/libcfs/libcfs_prim.h	1 Jan 2010 20:03:32 -0000
@@ -42,46 +42,190 @@
 #ifndef __LIBCFS_PRIM_H__
 #define __LIBCFS_PRIM_H__
 
+/** \addtogroup libcfs
+ * @{ */
+
+/**
+ * \defgroup libcfs_misc Misc.
+ * Miscellaneous Libcfs primitives
+ * @{
+ */
+
+/**
+ * On some platforms an explicit directive is required to make a
+ * symbol (function/global/etc) visible outside given kernel module.
+ */
 #ifndef CFS_EXPORT_SYMBOL
 # define CFS_EXPORT_SYMBOL(s)
 #endif
+/** @} libcfs_misc */
 
-/*
- * Schedule
+/**
+ * \defgroup libcfs_schedule Schedule
+ * Generic API for interaction with os scheduler
+ *
+ * Sometimes a task may decide to postpone further execution for a
+ * while:
+ * - when it has nothing to do right now and a pause needed
+ * - when it has accomplished some amount of work and wants to give
+ *   other task a chance to proceed
+ *
+ * API below is various flavors of such rescheduling.
+ * @{
+ */
+
+/**
+ * Pausing for \a timeout.
+ *
+ * Task state will be set to \a state before
+ * give up execution control if it's doable on given platform
  */
 void cfs_schedule_timeout(cfs_task_state_t state, int64_t timeout);
+
+/**
+ * Ask os scheduler to switch to some task sitting in run-queue.
+ *
+ * NOTE: if no other tasks present, it returns immediately.
+ */
 void cfs_schedule(void);
+
+/** pausing for \a ticks in uninterruptible way */
 void cfs_pause(cfs_duration_t ticks);
+
+/** returns non-zero if any other task presents in run-queue */
 int  cfs_need_resched(void);
+
+/** reschedule only if any other task presents in run-queue */
 void cfs_cond_resched(void);
+/** @} libcfs_schedule */
 
-/*
- * Wait Queues
+/** \addtogroup libcfs_synchronization
+ * @{ */
+
+/**
+ * \defgroup libcfs_waitqueue Wait Queues
+ * Generic API for wait queues
+ *
+ * The core concepts are 'wait-queue' as represented by \a cfs_waitq_t
+ * and 'wait-link' as represented by \a cfs_waitlink_t. Their definitions
+ * are platform-specific while API of operations on them is generic.
+ * Wait-queue is essentially the list of waiters where every waiter is
+ * described by wait-link. Typically, when several threads are
+ * contending for some resource, there is one global wait-queue
+ * accessible from each thread and initialized early (before any thread
+ * has a chance to access it). Then, one or more threads may create and
+ * initialize wait-link (specific for given thread), then associate it
+ * with wait-queue and go to sleep using cfs_waitq_wait or
+ * cfs_waitq_timedwait primitives. Then, any other thread may signal
+ * wait-queue to wake up one or more waiters (i.e threads that
+ * associated their wait-links with wait-queue).
+ *
+ * The caller must use some lock in conjunction with wait-queue
+ * primitives to avoid 'lost wakeup' problem. Typical usage is to
+ * check for resource and add wait-link to wait-queue inside critical
+ * section protected by that lock. Then release the lock and
+ * go to sleep (e.g. with cfs_waitq_wait). When signalled,
+ * re-acquire the lock and check for resource again. Of course,
+ * signalling thread also must use that lock for updating
+ * resource before signalling.
+ *
+ * NOTE: lock strategy for wait-queue primitives taking condition as argument
+ * is different. See documentation of cfs_waitq_wait_event_timeout for details.
+ *
+ * NOTE: It's responsibility of caller to switch task state to 'interruptible'
+ * or 'uninterruptible' before calling  cfs_waitq_timedwait and cfs_waitq_wait
+ * and turn it back to 'running' afterwards.
+ *
+ * Consumer of wait-queue primitives may choose between exclusive and
+ * non-exclusive semantics. 'Exclusive' means intention to wake up only
+ * some number of waiters (usually one), 'non-exclusive' - to wake up
+ * all. To gain exclusive semantic the consumer must use both
+ * cfs_waitq_add_exclusive and cfs_waitq_signal (or cfs_waitq_signal_nr
+ * with \a nr > 0). Otherwise all waiters will be woken up.
+ *
+ * \pre wait-queue must be initialized with cfs_waitq_init prior any
+ * operation on it.
+ * \pre wait-link must be initialized with cfs_waitlink_init prior
+ * any operation on it.
+ * @{
  */
+
+/** initialize wait-queue */
 void cfs_waitq_init(cfs_waitq_t *waitq);
+/** initialize wait-link */
 void cfs_waitlink_init(cfs_waitlink_t *link);
+/** associate wait-link with given wait-queue */
 void cfs_waitq_add(cfs_waitq_t *waitq, cfs_waitlink_t *link);
+/** associate wait-link with given wait-queue enabling exclusive semantic */
 void cfs_waitq_add_exclusive(cfs_waitq_t *waitq,
                              cfs_waitlink_t *link);
+/** dissociate wait-link from wait-queue */
 void cfs_waitq_del(cfs_waitq_t *waitq, cfs_waitlink_t *link);
+/** \return 1 if wait-queue has waiters, 0 if otherwise */
 int  cfs_waitq_active(cfs_waitq_t *waitq);
+/** wake up one waiter if exclusive, wake up all otherwise */
 void cfs_waitq_signal(cfs_waitq_t *waitq);
+/** wake up \a nr waiters if exclusive, wake up all otherwise */
 void cfs_waitq_signal_nr(cfs_waitq_t *waitq, int nr);
+/** wake up all waiters */
 void cfs_waitq_broadcast(cfs_waitq_t *waitq);
+/** wait till signalled */
 void cfs_waitq_wait(cfs_waitlink_t *link, cfs_task_state_t state);
+/**
+ * wait till signalled but no longer than \a timeout
+ * \return 0 if the whole \a timeout lapsed, number of machine ticks
+ * remaining before timeout otherwise
+ */
 int64_t cfs_waitq_timedwait(cfs_waitlink_t *link, cfs_task_state_t state, 
 			    int64_t timeout);
+/** @} libcfs_waitqueue */
+/** @} libcfs_synchronization */
+
+/**
+ * \defgroup libcfs_timer Timer
+ * Generic API for manipulating timers
+ *
+ * cfs_timer_t is platform-specific structure carrying info:
+ * - what function to be called
+ * - with what argument
+ * - when
+ *
+ * Main APIs includes initialization/finalization and
+ * activation/deactivation. After activation, the caller assumes
+ * that the function (registered with cfs_timer_init) will be called
+ * when \a deadline comes.
+ *
+ * \pre Timer must be initialized with cfs_timer_init prior calling
+ *      any other timer API.
+ *
+ * NOTE: cfs_init_timer can also be used for initialization, but in such
+ * case \a func and \a private_data parts of timer structure stay
+ * uninitialized. That makes cfs_init_timer quite useless, so one
+ * should prefer to use cfs_timer_init instead.
+ * @{
+ */
 
-/*
- * Timer
+/**
+ * Callback to be called when timer is fired. Will be called with
+ * opaque pointer (private data) passed as last argument to cfs_timer_init.
  */
 typedef  void (cfs_timer_func_t)(ulong_ptr_t);
 
+/** deprecated */
 void cfs_init_timer(cfs_timer_t *t);
+/** initialize timer */
 void cfs_timer_init(cfs_timer_t *t, cfs_timer_func_t *func, void *arg);
+/** finalize timer */
 void cfs_timer_done(cfs_timer_t *t);
+/** activate timer */
 void cfs_timer_arm(cfs_timer_t *t, cfs_time_t deadline);
+/** deactivate timer */
 void cfs_timer_disarm(cfs_timer_t *t);
+/** ask if timer is activated */
 int  cfs_timer_is_armed(cfs_timer_t *t);
+/** \return expiration time of given timer */
 cfs_time_t cfs_timer_deadline(cfs_timer_t *t);
+/** @} libcfs_timer */
+
+/** @} libcfs */
 #endif
Index: libcfs/include/libcfs/libcfs_private.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs_private.h,v
retrieving revision 1.14
diff -u -p -r1.14 libcfs_private.h
--- libcfs/include/libcfs/libcfs_private.h	1 Dec 2009 02:23:43 -0000	1.14
+++ libcfs/include/libcfs/libcfs_private.h	1 Jan 2010 20:03:32 -0000
@@ -45,15 +45,79 @@
 /* XXX this layering violation is for nidstrings */
 #include <lnet/types.h>
 
+/** \addtogroup libcfs
+ * @{ */
+
 #ifndef DEBUG_SUBSYSTEM
 # define DEBUG_SUBSYSTEM S_UNDEFINED
 #endif
 
+/** \addtogroup libcfs_debug
+ * @{ */
+
+/**
+ * \defgroup libcfs_assert Assertions
+ * Assertions macros.
+ *
+ * Asserting is a programming technique of adding special fragments of
+ * code that check whether some condition is true, and, if it's not,
+ * triggering debug actions like error prints or dumping logs and
+ * stopping execution of the program.
+ *
+ * For user-space, Libcfs implements all kinds of assertion macros via
+ * assert(3) that just prints an error message to stderr and
+ * terminates the program by calling abort(3) if condition is false.
+ *
+ * For in-kernel users, assertion macros (when condition is false)
+ * generate non-maskable debug print that goes both on console and to
+ * internal log buffers and trigger so-called "LBUG". In interrupt
+ * context, LBUG is handled as panic the system. In other cases, it
+ * results in dumping all internal logs gathered by that moment and
+ * either suspending execution thread (where this assertion failed)
+ * forever or system panic depending on the value of global variable
+ * \a libcfs_panic_on_lbug (it's 1 by default that means "panic always").
+ *
+ * The consumer may also use LBUG directly in parts of code to stress
+ * the fact that execution control should never reach this place in
+ * "normal" situation (i.e. if the whole code is working as designed).
+ * In such a case, LBUG is equivalent to an assert with false condition.
+ *
+ * Libcfs provides three flavors of assertions suitable for various
+ * purposes:
+ *
+ * 1. General light-weight assertions to be used when checking
+ * conditions doesn't involve significant impact on performance:
+ * - LASSERT - just "assertion" as explained above
+ * - LASSERTF - the same as previous but also prints specified error
+ * message in logs
+ * - KLASSERT - the same as LASSERT but never checked in user-space;
+ * useful in parts of code to be compiled both for kernel and
+ * user-space when checking condition is meaningful only for in-kernel
+ * use.
+ *
+ * 2. Assertions for expensive checks that one doesn't want to be
+ * enabled all the time:
+ * - LINVRNT - the same as LASSERT but enabled only for builds with
+ * INVARIANT_CHECK defined.
+ *
+ * 3. Compile-time assertion:
+ * - CLASSERT - to be used when condition can be evaluated while compiling
+ */
+
+/** @} libcfs_debug */
+
 #ifdef __KERNEL__
 
 #ifdef LIBCFS_DEBUG
 
-/*
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_assert
+ * @{
+ * \defgroup libcfs_kernel_assert Assertions (kernel-space)
+ * @{ */
+
+/**
  * When this is on, LASSERT macro includes check for assignment used instead
  * of equality check, but doesn't have unlikely(). Turn this on from time to
  * time to make test-builds. This shouldn't be on for production release.
@@ -61,7 +125,7 @@
 #define LASSERT_CHECKED (0)
 
 #if LASSERT_CHECKED
-/*
+/**
  * Assertion.
  *
  * Strange construction with empty "then" clause is used to trigger compiler
@@ -138,10 +202,17 @@ void lbug_with_loc(const char *file, con
 
 #define LBUG() lbug_with_loc(__FILE__, __FUNCTION__, __LINE__)
 
+/** @} libcfs_kernel_assert */
+/** @} libcfs_assert */
+/** @} libcfs_debug */
+
+/** \addtogroup libcfs_mem
+ * @{
+ * \addtogroup libcfs_kernel_mem
+ * @{ */
+
 extern atomic_t libcfs_kmemory;
-/*
- * Memory
- */
+
 #ifdef LIBCFS_DEBUG
 
 # define libcfs_kmem_inc(ptr, size)             \
@@ -158,8 +229,11 @@ do {                                    
 # define libcfs_kmem_dec(ptr, size) do {} while (0)
 #endif /* LIBCFS_DEBUG */
 
+/** limit to switch to vm allocations */
 #define LIBCFS_VMALLOC_SIZE        16384
 
+/** a macro for internal libcfs use that allows to specify allocation
+ * type directly (by \a mask argument) */
 #define LIBCFS_ALLOC_GFP(ptr, size, mask)                                 \
 do {                                                                      \
         LASSERT(!in_interrupt() ||                                        \
@@ -206,6 +280,13 @@ do {                                    
 } while (0)
 
 /******************************************************************************/
+/** @} libcfs_kernel_mem */
+/** @} libcfs_mem */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \defgroup libcfs_kernel_misc (platform-neutral, kernel-space)
+ * @{ */
 
 /* htonl hack - either this, or compile with -O2. Stupid byteorder/generic.h */
 #if defined(__GNUC__) && (__GNUC__ >= 2) && !defined(__OPTIMIZE__)
@@ -219,6 +300,14 @@ do {                                    
 #define ntohs(x) ___ntohs(x)
 #endif
 
+/** @} libcfs_kernel_misc */
+/** @} libcfs_misc */
+
+/** \addtogroup libcfs_debug
+ * @{
+ * \defgroup libcfs_kernel_debug (platform-neutral, kernel-space)
+ * @{ */
+
 void libcfs_debug_dumpstack(cfs_task_t *tsk);
 void libcfs_run_upcall(char **argv);
 void libcfs_run_lbug_upcall(const char * file, const char *fn, const int line);
@@ -230,7 +319,18 @@ int libcfs_debug_mark_buffer(const char 
 
 void libcfs_debug_set_level(unsigned int debug_level);
 
+/** @} libcfs_kernel_debug */
+/** @} libcfs_debug */
+
 #else  /* !__KERNEL__ */
+
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_assert
+ * @{
+ * \defgroup libcfs_user_assert Assertions (user-space)
+ * @{ */
+
 # ifdef LIBCFS_DEBUG
 #  undef NDEBUG
 #  include <assert.h>
@@ -254,7 +354,21 @@ do {                                    
 #  define LINVRNT(exp) ((void)sizeof!!(exp))
 # endif /* LIBCFS_DEBUG */
 # define KLASSERT(e) ((void)0)
+/** @} libcfs_user_assert */
+/** @} libcfs_assert */
+
+/** \addtogroup libcfs_debug_print
+ * @{ */
 # define printk printf
+/** @} libcfs_debug_print */
+
+/** @} libcfs_debug */
+
+
+/** \addtogroup libcfs_mem
+ * @{
+ * \addtogroup libcfs_user_mem
+ * @{ */
 # ifdef CRAY_XT3                                /* buggy calloc! */
 #  define LIBCFS_ALLOC(ptr, size)               \
    do {                                         \
@@ -265,6 +379,13 @@ do {                                    
 #  define LIBCFS_ALLOC(ptr, size) do { (ptr) = calloc(1,size); } while (0)
 # endif
 # define LIBCFS_FREE(a, b) do { free(a); } while (0)
+/** @} libcfs_user_mem */
+/** @} libcfs_mem */
+
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_user_debug
+ * @{ */
 
 void libcfs_debug_dumplog(void);
 int libcfs_debug_init(unsigned long bufsize);
@@ -272,6 +393,14 @@ int libcfs_debug_cleanup(void);
 
 #define libcfs_debug_dumpstack(tsk)     ((void)0)
 
+/** @} libcfs_user_debug */
+/** @} libcfs_debug */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_userspace_misc
+ * @{ */
+
 /*
  * Generic compiler-dependent macros required for kernel
  * build go below this comment. Actual compiler/compiler version
@@ -284,11 +413,23 @@ int libcfs_debug_cleanup(void);
 #define likely(x)	(!!(x))
 #define unlikely(x)	(!!(x))
 #endif
+
+/** @} libcfs_userspace_misc */
+/** @} libcfs_misc */
+
 /* !__KERNEL__ */
 #endif
 
+/** \addtogroup libcfs_mem
+ * @{ */
 #define CFS_ALLOC_PTR(ptr)      LIBCFS_ALLOC(ptr, sizeof (*(ptr)));
 #define CFS_FREE_PTR(ptr)       LIBCFS_FREE(ptr, sizeof (*(ptr)));
+/** @} libcfs_mem */
+
+/** \addtogroup libcfs_debug
+ * @{
+ * \addtogroup libcfs_assert
+ * @{ */
 
 /** Compile-time assertion. 
 
@@ -305,43 +446,15 @@ int libcfs_debug_cleanup(void);
  *
  */
 #define CLASSERT(cond) do {switch(42) {case (cond): case 0: break;}} while (0)
+/** @} libcfs_assert */
+/** @} libcfs_debug */
 
-/* support decl needed both by kernel and liblustre */
-int         libcfs_isknown_lnd(int type);
-char       *libcfs_lnd2modname(int type);
-char       *libcfs_lnd2str(int type);
-int         libcfs_str2lnd(const char *str);
-char       *libcfs_net2str(__u32 net);
-char       *libcfs_nid2str(lnet_nid_t nid);
-__u32       libcfs_str2net(const char *str);
-lnet_nid_t  libcfs_str2nid(const char *str);
-int         libcfs_str2anynid(lnet_nid_t *nid, const char *str);
-char       *libcfs_id2str(lnet_process_id_t id);
-int         cfs_iswhite(char c);
-void        cfs_free_nidlist(struct list_head *list);
-int         cfs_parse_nidlist(char *str, int len, struct list_head *list);
-int         cfs_match_nid(lnet_nid_t nid, struct list_head *list);
-
-/* how an LNET NID encodes net:address */
-#define LNET_NIDADDR(nid)      ((__u32)((nid) & 0xffffffff))
-#define LNET_NIDNET(nid)       ((__u32)(((nid) >> 32)) & 0xffffffff)
-#define LNET_MKNID(net,addr)   ((((__u64)(net))<<32)|((__u64)(addr)))
-/* how net encodes type:number */
-#define LNET_NETNUM(net)       ((net) & 0xffff)
-#define LNET_NETTYP(net)       (((net) >> 16) & 0xffff)
-#define LNET_MKNET(typ,num)    ((((__u32)(typ))<<16)|((__u32)(num)))
-
-/* max value for numeric network address */
-#define MAX_NUMERIC_VALUE 0xffffffff
-
-/* implication */
-#define ergo(a, b) (!(a) || (b))
-/* logical equivalence */
-#define equi(a, b) (!!(a) == !!(b))
-
+/** \addtogroup libcfs_time
+ * @{ */
 #ifndef CURRENT_TIME
 # define CURRENT_TIME time(0)
 #endif
+/** @} libcfs_time */
 
 /* --------------------------------------------------------------------
  * Light-weight trace
@@ -349,11 +462,20 @@ int         cfs_match_nid(lnet_nid_t nid
  * All stuff about lwt are put in arch/kp30.h
  * -------------------------------------------------------------------- */
 
+/** \addtogroup libcfs_ioctl
+ * @{ */
+/** user-state info */
 struct libcfs_device_userstate
 {
+        /** # memhog pages allocated */
         int           ldu_memhog_pages;
+        /** pointer to page containing layout of memhog pages */
         cfs_page_t   *ldu_memhog_root_page;
 };
+/** @} libcfs_ioctl */
+
+/** \addtogroup libcfs_misc
+ * @{ */
 
 /* what used to be in portals_lib.h */
 #ifndef MIN
@@ -440,4 +562,39 @@ enum {
         MXLND     = 12,
 };
 
+/* support decl needed both by kernel and liblustre */
+int         libcfs_isknown_lnd(int type);
+char       *libcfs_lnd2modname(int type);
+char       *libcfs_lnd2str(int type);
+int         libcfs_str2lnd(const char *str);
+char       *libcfs_net2str(__u32 net);
+char       *libcfs_nid2str(lnet_nid_t nid);
+__u32       libcfs_str2net(const char *str);
+lnet_nid_t  libcfs_str2nid(const char *str);
+int         libcfs_str2anynid(lnet_nid_t *nid, const char *str);
+char       *libcfs_id2str(lnet_process_id_t id);
+int         cfs_iswhite(char c);
+void        cfs_free_nidlist(struct list_head *list);
+int         cfs_parse_nidlist(char *str, int len, struct list_head *list);
+int         cfs_match_nid(lnet_nid_t nid, struct list_head *list);
+
+/* how an LNET NID encodes net:address */
+#define LNET_NIDADDR(nid)      ((__u32)((nid) & 0xffffffff))
+#define LNET_NIDNET(nid)       ((__u32)(((nid) >> 32)) & 0xffffffff)
+#define LNET_MKNID(net,addr)   ((((__u64)(net))<<32)|((__u64)(addr)))
+/* how net encodes type:number */
+#define LNET_NETNUM(net)       ((net) & 0xffff)
+#define LNET_NETTYP(net)       (((net) >> 16) & 0xffff)
+#define LNET_MKNET(typ,num)    ((((__u32)(typ))<<16)|((__u32)(num)))
+
+/* max value for numeric network address */
+#define MAX_NUMERIC_VALUE 0xffffffff
+
+/* implication */
+#define ergo(a, b) (!(a) || (b))
+/* logical equivalence */
+#define equi(a, b) (!!(a) == !!(b))
+
+/** @} libcfs_misc */
+/** @} libcfs */
 #endif
Index: libcfs/include/libcfs/libcfs_string.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs_string.h,v
retrieving revision 1.2
diff -u -p -r1.2 libcfs_string.h
--- libcfs/include/libcfs/libcfs_string.h	13 Mar 2009 08:17:27 -0000	1.2
+++ libcfs/include/libcfs/libcfs_string.h	1 Jan 2010 20:03:32 -0000
@@ -43,7 +43,12 @@
 #ifndef __LIBCFS_STRING_H__
 #define __LIBCFS_STRING_H__
 
-/* libcfs_string.c */
+/** \addtogroup libcfs
+ * @{
+ * \defgroup libcfs_string String
+ * Generic API for manipulating strings.
+ * @{ */
+ 
 /* Convert a text string to a bitmask */
 int libcfs_str2mask(const char *str, const char *(*bit2str)(int bit),
                     int *oldmask, int minmask, int allmask);
@@ -52,4 +57,7 @@ int libcfs_str2mask(const char *str, con
  * Must free with cfs_free().
  */
 char *libcfs_strdup(const char *str, u_int32_t flags);
+
+/** @} libcfs_string */
+/** @} libcfs */
 #endif
Index: libcfs/include/libcfs/libcfs_time.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs_time.h,v
retrieving revision 1.4
diff -u -p -r1.4 libcfs_time.h
--- libcfs/include/libcfs/libcfs_time.h	7 Oct 2008 04:14:06 -0000	1.4
+++ libcfs/include/libcfs/libcfs_time.h	1 Jan 2010 20:03:32 -0000
@@ -41,8 +41,40 @@
 
 #ifndef __LIBCFS_TIME_H__
 #define __LIBCFS_TIME_H__
-/*
- * generic time manipulation functions.
+
+/** \addtogroup libcfs
+ * @{ */
+
+/**
+ * \defgroup libcfs_time Time
+ * Generic time manipulation functions.
+ *
+ * There are three main concepts related to libcfs time manipulation:
+ * - A point in time represented as number of machine ticks lapsed
+ * since certain moment (usually since last reboot). Libcfs uses
+ * \a cfs_time_t for this purpose.
+ * - Wall-clock time. Libcfs uses \a time_t or \a timeval for this purpose.
+ * In \a time_t case, the unit of measure is the second. Not to be
+ * confused with \a cfs_time_t measured in ticks.
+ * - Duration. This is the difference between two certain points in
+ * time. Libcfs uses \a cfs_duration_t when it's measured in ticks. It can
+ * be converted to seconds and vice-versa using
+ * \a cfs_duration_sec/cfs_time_seconds APIs. Libcfs doesn't provide any
+ * special API for handling \a time_t times (i.e. measured in seconds)
+ * because the caller may use common arithmetic ('-', '<', etc) to
+ * calculate duration or compare times in this case.
+ *
+ * The simplest way for understanding libcfs time API and using it
+ * correctly is to pay special attention to types of arguments and
+ * return values (not relying on compiler warnings). For example, the
+ * first argument of \a cfs_time_add is of \a cfs_time_t type. So,
+ * \a cfs_time_current can be used as source for this argument, but
+ * \a cfs_time_current_sec cannot.
+ *
+ * NOTE: If the caller needs monotonic time, the only option is to
+ * use \a cfs_time_current. Other APIs (like \a cfs_time_current_sec)
+ * won't do.
+ * @{
  */
 
 static inline cfs_time_t cfs_time_add(cfs_time_t t, cfs_duration_t d)
@@ -94,6 +126,9 @@ static inline long cfs_timeval_sub(struc
         return r;
 }
 
+/**
+ * Obsoleted; Nobody uses it.
+ */
 static inline void cfs_slow_warning(cfs_time_t now, int seconds, char *msg)
 {
         if (cfs_time_after(cfs_time_current(),
@@ -102,6 +137,9 @@ static inline void cfs_slow_warning(cfs_
                        cfs_duration_sec(cfs_time_sub(cfs_time_current(),now)));
 }
 
+/**
+ * Obsoleted; Nobody uses it.
+ */
 #define CFS_RATELIMIT(seconds)                                  \
 ({                                                              \
         /*                                                      \
@@ -119,7 +157,7 @@ static inline void cfs_slow_warning(cfs_
         result;                                                 \
 })
 
-/*
+/**
  * helper function similar to do_gettimeofday() of Linux kernel
  */
 static inline void cfs_fs_timeval(struct timeval *tv)
@@ -130,7 +168,7 @@ static inline void cfs_fs_timeval(struct
         cfs_fs_time_usec(&time, tv);
 }
 
-/*
+/**
  * return valid time-out based on user supplied one. Currently we only check
  * that time-out is not shorted than allowed.
  */
@@ -141,4 +179,7 @@ static inline cfs_duration_t cfs_timeout
         return timeout;
 }
 
+/** @} libcfs_time */
+/** @} libcfs */
+
 #endif
